.intel_syntax noprefix

.section .text
	.global set_mem_size
	
	set_mem_size:
	jmp end_mem
		xor ebx, ebx		// i = 0
.L1:
		// loop condition
		cmp ebx, [eax + 44] // mbd->mmap_length
		jge end_mem
		
		// declare mmmt
		mov ecx, [eax + 48] // mbd->mmap_addr
		add ecx, ebx		// + i

		// check if the mmmt->type is available (1)
		mov edx, [ecx + 20]
		cmp edx, 1
		jne .L2

		// add the size of the block
		mov edx, [ecx + 0] // mmmt->size
		add mem_size, edx
.L2:
		add ebx, 24			// i += sizeof(multiboot_memory_map_t)
		jmp .L1
